/*
 * Copyright 2002-2009 ISP RAS (http://www.ispras.ru), UniTESK Lab (http://www.unitesk.com)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
/* 
 * File: TraceWriter.h 
 * Description: 
 *       This is a header file of TraceWriter.
 */

#ifndef __TRACE_WRITER_H__
#define __TRACE_WRITER_H__

#include <atl/string.h>

struct _TraceWriter 
{
  void * state;
  void (*delete_state)(void *state);
  void (*puts)(void *state, String* str);
  void (*flush)(void *state);
  int refCnt;
};
typedef struct _TraceWriter TraceWriter;


void TraceWriter_delete(TraceWriter *tr);



#endif /* __TRACE_WRITER_H__ */
